##// END OF EJS Templates
Fix default KERNEL_DEFAULT_GOV value - as in README file.
Michał Ciołek -
r600:20fabc622fbe
parent child
Show More
@@ -1,892 +1,892
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63 # Kernel deb packages for 32bit kernel
63 # Kernel deb packages for 32bit kernel
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 # Default precompiled 64bit kernel
68 # Default precompiled 64bit kernel
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 # Generic
70 # Generic
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74
74
75 # Build directories
75 # Build directories
76 WORKDIR=$(pwd)
76 WORKDIR=$(pwd)
77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 BUILDDIR="${BASEDIR}/build"
78 BUILDDIR="${BASEDIR}/build"
79
79
80 # Chroot directories
80 # Chroot directories
81 R="${BUILDDIR}/chroot"
81 R="${BUILDDIR}/chroot"
82 ETC_DIR="${R}/etc"
82 ETC_DIR="${R}/etc"
83 LIB_DIR="${R}/lib"
83 LIB_DIR="${R}/lib"
84 BOOT_DIR="${R}/boot/firmware"
84 BOOT_DIR="${R}/boot/firmware"
85 KERNEL_DIR="${R}/usr/src/linux"
85 KERNEL_DIR="${R}/usr/src/linux"
86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88
88
89 # Firmware directory: Blank if download from github
89 # Firmware directory: Blank if download from github
90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91
91
92 # General settings
92 # General settings
93 SET_ARCH=${SET_ARCH:=32}
93 SET_ARCH=${SET_ARCH:=32}
94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 PASSWORD=${PASSWORD:=raspberry}
95 PASSWORD=${PASSWORD:=raspberry}
96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 EXPANDROOT=${EXPANDROOT:=true}
99 EXPANDROOT=${EXPANDROOT:=true}
100
100
101 # Keyboard settings
101 # Keyboard settings
102 XKB_MODEL=${XKB_MODEL:=""}
102 XKB_MODEL=${XKB_MODEL:=""}
103 XKB_LAYOUT=${XKB_LAYOUT:=""}
103 XKB_LAYOUT=${XKB_LAYOUT:=""}
104 XKB_VARIANT=${XKB_VARIANT:=""}
104 XKB_VARIANT=${XKB_VARIANT:=""}
105 XKB_OPTIONS=${XKB_OPTIONS:=""}
105 XKB_OPTIONS=${XKB_OPTIONS:=""}
106
106
107 # Network settings (DHCP)
107 # Network settings (DHCP)
108 ENABLE_DHCP=${ENABLE_DHCP:=true}
108 ENABLE_DHCP=${ENABLE_DHCP:=true}
109
109
110 # Network settings (static)
110 # Network settings (static)
111 NET_ADDRESS=${NET_ADDRESS:=""}
111 NET_ADDRESS=${NET_ADDRESS:=""}
112 NET_GATEWAY=${NET_GATEWAY:=""}
112 NET_GATEWAY=${NET_GATEWAY:=""}
113 NET_DNS_1=${NET_DNS_1:=""}
113 NET_DNS_1=${NET_DNS_1:=""}
114 NET_DNS_2=${NET_DNS_2:=""}
114 NET_DNS_2=${NET_DNS_2:=""}
115 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
115 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
116 NET_NTP_1=${NET_NTP_1:=""}
116 NET_NTP_1=${NET_NTP_1:=""}
117 NET_NTP_2=${NET_NTP_2:=""}
117 NET_NTP_2=${NET_NTP_2:=""}
118
118
119 # APT settings
119 # APT settings
120 APT_PROXY=${APT_PROXY:=""}
120 APT_PROXY=${APT_PROXY:=""}
121 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
121 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
122 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
122 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
123
123
124 # Feature settings
124 # Feature settings
125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 ENABLE_I2C=${ENABLE_I2C:=false}
129 ENABLE_I2C=${ENABLE_I2C:=false}
130 ENABLE_SPI=${ENABLE_SPI:=false}
130 ENABLE_SPI=${ENABLE_SPI:=false}
131 ENABLE_IPV6=${ENABLE_IPV6:=true}
131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 ENABLE_SSHD=${ENABLE_SSHD:=true}
132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 ENABLE_SOUND=${ENABLE_SOUND:=true}
135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 ENABLE_DBUS=${ENABLE_DBUS:=true}
136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 ENABLE_XORG=${ENABLE_XORG:=false}
139 ENABLE_XORG=${ENABLE_XORG:=false}
140 ENABLE_WM=${ENABLE_WM:=""}
140 ENABLE_WM=${ENABLE_WM:=""}
141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 ENABLE_USER=${ENABLE_USER:=true}
142 ENABLE_USER=${ENABLE_USER:=true}
143 USER_NAME=${USER_NAME:="pi"}
143 USER_NAME=${USER_NAME:="pi"}
144 ENABLE_ROOT=${ENABLE_ROOT:=false}
144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 ENABLE_QEMU=${ENABLE_QEMU:=false}
145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
148
148
149 # SSH settings
149 # SSH settings
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155
155
156 # Advanced settings
156 # Advanced settings
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 ENABLE_LOGO=${ENABLE_LOGO:=true}
175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178
178
179 # Kernel compilation settings
179 # Kernel compilation settings
180 BUILD_KERNEL=${BUILD_KERNEL:=true}
180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 KERNEL_THREADS=${KERNEL_THREADS:=1}
182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 KERNEL_VIRT=${KERNEL_VIRT:=false}
189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 KERNEL_BPF=${KERNEL_BPF:=false}
190 KERNEL_BPF=${KERNEL_BPF:=false}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 KERNEL_NF=${KERNEL_NF:=false}
193 KERNEL_NF=${KERNEL_NF:=false}
194
194
195 # Kernel compilation from source directory settings
195 # Kernel compilation from source directory settings
196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200
200
201 # Reduce disk usage settings
201 # Reduce disk usage settings
202 REDUCE_APT=${REDUCE_APT:=true}
202 REDUCE_APT=${REDUCE_APT:=true}
203 REDUCE_DOC=${REDUCE_DOC:=true}
203 REDUCE_DOC=${REDUCE_DOC:=true}
204 REDUCE_MAN=${REDUCE_MAN:=true}
204 REDUCE_MAN=${REDUCE_MAN:=true}
205 REDUCE_VIM=${REDUCE_VIM:=false}
205 REDUCE_VIM=${REDUCE_VIM:=false}
206 REDUCE_BASH=${REDUCE_BASH:=false}
206 REDUCE_BASH=${REDUCE_BASH:=false}
207 REDUCE_HWDB=${REDUCE_HWDB:=true}
207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 REDUCE_SSHD=${REDUCE_SSHD:=true}
208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210
210
211 # Encrypted filesystem settings
211 # Encrypted filesystem settings
212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221
221
222 # Chroot scripts directory
222 # Chroot scripts directory
223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224
224
225 # Packages required in the chroot build environment
225 # Packages required in the chroot build environment
226 APT_INCLUDES=${APT_INCLUDES:=""}
226 APT_INCLUDES=${APT_INCLUDES:=""}
227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228
228
229 # Packages to exclude from chroot build environment
229 # Packages to exclude from chroot build environment
230 APT_EXCLUDES=${APT_EXCLUDES:=""}
230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231
231
232 # Packages required for bootstrapping
232 # Packages required for bootstrapping
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
234 #Requierd=netselect-apt
234 #Requierd=netselect-apt
235 MISSING_PACKAGES=""
235 MISSING_PACKAGES=""
236
236
237 # Packages installed for c/c++ build environment in chroot (keep empty)
237 # Packages installed for c/c++ build environment in chroot (keep empty)
238 COMPILER_PACKAGES=""
238 COMPILER_PACKAGES=""
239
239
240 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
240 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
241 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
241 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
242 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
242 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
243 APT_PROXY=http://127.0.0.1:3142/
243 APT_PROXY=http://127.0.0.1:3142/
244 fi
244 fi
245
245
246 # netselect-apt does not know buster yet
246 # netselect-apt does not know buster yet
247 #if [ "$RELEASE" = "buster" ] ; then
247 #if [ "$RELEASE" = "buster" ] ; then
248 # RLS=testing
248 # RLS=testing
249 #else
249 #else
250 # RLS="$RELEASE"
250 # RLS="$RELEASE"
251 #fi
251 #fi
252
252
253 #if [ -f "$(pwd)/files/apt/sources.list" ] ; then
253 #if [ -f "$(pwd)/files/apt/sources.list" ] ; then
254 #rm "$(pwd)/files/apt/sources.list"
254 #rm "$(pwd)/files/apt/sources.list"
255 #fi
255 #fi
256
256
257 #if [ "$ENABLE_NONFREE" = true ] ; then
257 #if [ "$ENABLE_NONFREE" = true ] ; then
258 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
258 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
259 #else
259 #else
260 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
260 # netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
261 #fi
261 #fi
262
262
263 # sed and cut the result string so we can use it as APT_SERVER
263 # sed and cut the result string so we can use it as APT_SERVER
264 #APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
264 #APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
265
265
266 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
266 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
267 if [ -n "$SET_ARCH" ] ; then
267 if [ -n "$SET_ARCH" ] ; then
268 # 64-bit configuration
268 # 64-bit configuration
269 if [ "$SET_ARCH" = 64 ] ; then
269 if [ "$SET_ARCH" = 64 ] ; then
270 # General 64-bit depended settings
270 # General 64-bit depended settings
271 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
271 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
272 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
272 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
273 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
273 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
274
274
275 # Raspberry Pi model specific settings
275 # Raspberry Pi model specific settings
276 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
276 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
279 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
279 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
281 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
281 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
282 else
282 else
283 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
283 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
284 exit 1
284 exit 1
285 fi
285 fi
286 fi
286 fi
287
287
288 # 32-bit configuration
288 # 32-bit configuration
289 if [ "$SET_ARCH" = 32 ] ; then
289 if [ "$SET_ARCH" = 32 ] ; then
290 # General 32-bit dependend settings
290 # General 32-bit dependend settings
291 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
291 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
292 KERNEL_ARCH=${KERNEL_ARCH:=arm}
292 KERNEL_ARCH=${KERNEL_ARCH:=arm}
293 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
293 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
294
294
295 # Raspberry Pi model specific settings
295 # Raspberry Pi model specific settings
296 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
296 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
297 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
297 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
298 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
298 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
299 RELEASE_ARCH=${RELEASE_ARCH:=armel}
299 RELEASE_ARCH=${RELEASE_ARCH:=armel}
300 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
300 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
301 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
301 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
302 fi
302 fi
303
303
304 # Raspberry Pi model specific settings
304 # Raspberry Pi model specific settings
305 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
305 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
307 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
307 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
308 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
308 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
310 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
310 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
311 fi
311 fi
312 fi
312 fi
313 # SET_ARCH not set
313 # SET_ARCH not set
314 else
314 else
315 echo "error: Please set '32' or '64' as value for SET_ARCH"
315 echo "error: Please set '32' or '64' as value for SET_ARCH"
316 exit 1
316 exit 1
317 fi
317 fi
318 # Device specific configuration and U-Boot configuration
318 # Device specific configuration and U-Boot configuration
319 case "$RPI_MODEL" in
319 case "$RPI_MODEL" in
320 0)
320 0)
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 ;;
323 ;;
324 1)
324 1)
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 ;;
327 ;;
328 1P)
328 1P)
329 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
329 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
331 ;;
331 ;;
332 2)
332 2)
333 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
333 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
335 ;;
335 ;;
336 3)
336 3)
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 ;;
339 ;;
340 3P)
340 3P)
341 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
341 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
342 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
342 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
343 ;;
343 ;;
344 *)
344 *)
345 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
345 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
346 exit 1
346 exit 1
347 ;;
347 ;;
348 esac
348 esac
349
349
350 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
350 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
351 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
351 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
352 # Include bluetooth packages on supported boards
352 # Include bluetooth packages on supported boards
353 if [ "$ENABLE_BLUETOOTH" = true ] ; then
353 if [ "$ENABLE_BLUETOOTH" = true ] ; then
354 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
354 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
355 fi
355 fi
356 if [ "$ENABLE_WIRELESS" = true ] ; then
356 if [ "$ENABLE_WIRELESS" = true ] ; then
357 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
357 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
358 fi
358 fi
359 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
359 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
360 # Check if the internal wireless interface is not supported by the RPi model
360 # Check if the internal wireless interface is not supported by the RPi model
361 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
361 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
362 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
362 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
363 exit 1
363 exit 1
364 fi
364 fi
365 fi
365 fi
366
366
367 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
367 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
368 echo "error: You have to compile kernel sources, if you want to enable nexmon"
368 echo "error: You have to compile kernel sources, if you want to enable nexmon"
369 exit 1
369 exit 1
370 fi
370 fi
371
371
372 # Prepare date string for default image file name
372 # Prepare date string for default image file name
373 DATE="$(date +%Y-%m-%d)"
373 DATE="$(date +%Y-%m-%d)"
374 if [ -z "$KERNEL_BRANCH" ] ; then
374 if [ -z "$KERNEL_BRANCH" ] ; then
375 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
375 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
376 else
376 else
377 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
377 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
378 fi
378 fi
379
379
380 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
380 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
381 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
381 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
382 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
382 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
383 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
383 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
384 exit 1
384 exit 1
385 fi
385 fi
386 fi
386 fi
387
387
388 set +x
388 set +x
389
389
390 # Add cmake to compile videocore sources
390 # Add cmake to compile videocore sources
391 if [ "$ENABLE_KEYGEN" = true ] ; then
391 if [ "$ENABLE_KEYGEN" = true ] ; then
392 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
392 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
393 fi
393 fi
394
394
395 # Add cmake to compile videocore sources
395 # Add cmake to compile videocore sources
396 if [ "$ENABLE_VIDEOCORE" = true ] ; then
396 if [ "$ENABLE_VIDEOCORE" = true ] ; then
397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
398 fi
398 fi
399
399
400 # Add deps for nexmon
400 # Add deps for nexmon
401 if [ "$ENABLE_NEXMON" = true ] ; then
401 if [ "$ENABLE_NEXMON" = true ] ; then
402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
403 fi
403 fi
404
404
405 # Add libncurses5 to enable kernel menuconfig
405 # Add libncurses5 to enable kernel menuconfig
406 if [ "$KERNEL_MENUCONFIG" = true ] ; then
406 if [ "$KERNEL_MENUCONFIG" = true ] ; then
407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
408 fi
408 fi
409
409
410 # Add ccache compiler cache for (faster) kernel cross (re)compilation
410 # Add ccache compiler cache for (faster) kernel cross (re)compilation
411 if [ "$KERNEL_CCACHE" = true ] ; then
411 if [ "$KERNEL_CCACHE" = true ] ; then
412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
413 fi
413 fi
414
414
415 # Add cryptsetup package to enable filesystem encryption
415 # Add cryptsetup package to enable filesystem encryption
416 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
418 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
418 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
419
419
420 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
420 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
421 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
421 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
422 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
422 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
423 fi
423 fi
424
424
425 if [ -z "$CRYPTFS_PASSWORD" ] ; then
425 if [ -z "$CRYPTFS_PASSWORD" ] ; then
426 echo "error: no password defined (CRYPTFS_PASSWORD)!"
426 echo "error: no password defined (CRYPTFS_PASSWORD)!"
427 exit 1
427 exit 1
428 fi
428 fi
429 ENABLE_INITRAMFS=true
429 ENABLE_INITRAMFS=true
430 fi
430 fi
431
431
432 # Add initramfs generation tools
432 # Add initramfs generation tools
433 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
433 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
434 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
434 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
435 fi
435 fi
436
436
437 # Add device-tree-compiler required for building the U-Boot bootloader
437 # Add device-tree-compiler required for building the U-Boot bootloader
438 if [ "$ENABLE_UBOOT" = true ] ; then
438 if [ "$ENABLE_UBOOT" = true ] ; then
439 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
439 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
440 fi
440 fi
441
441
442 if [ "$ENABLE_USBBOOT" = true ] ; then
442 if [ "$ENABLE_USBBOOT" = true ] ; then
443 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
443 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
444 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
444 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
445 exit 1
445 exit 1
446 fi
446 fi
447 fi
447 fi
448
448
449 # Check if root SSH (v2) public key file exists
449 # Check if root SSH (v2) public key file exists
450 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
450 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
451 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
451 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
452 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
452 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
453 exit 1
453 exit 1
454 fi
454 fi
455 fi
455 fi
456
456
457 # Check if $USER_NAME SSH (v2) public key file exists
457 # Check if $USER_NAME SSH (v2) public key file exists
458 if [ -n "$SSH_USER_PUB_KEY" ] ; then
458 if [ -n "$SSH_USER_PUB_KEY" ] ; then
459 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
459 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
460 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
460 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
461 exit 1
461 exit 1
462 fi
462 fi
463 fi
463 fi
464
464
465 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
465 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
466 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
466 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
467 exit 1
467 exit 1
468 fi
468 fi
469
469
470 # Check if all required packages are installed on the build system
470 # Check if all required packages are installed on the build system
471 for package in $REQUIRED_PACKAGES ; do
471 for package in $REQUIRED_PACKAGES ; do
472 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
472 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
473 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
473 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
474 fi
474 fi
475 done
475 done
476
476
477 # If there are missing packages ask confirmation for install, or exit
477 # If there are missing packages ask confirmation for install, or exit
478 if [ -n "$MISSING_PACKAGES" ] ; then
478 if [ -n "$MISSING_PACKAGES" ] ; then
479 echo "the following packages needed by this script are not installed:"
479 echo "the following packages needed by this script are not installed:"
480 echo "$MISSING_PACKAGES"
480 echo "$MISSING_PACKAGES"
481
481
482 printf "\ndo you want to install the missing packages right now? [y/n] "
482 printf "\ndo you want to install the missing packages right now? [y/n] "
483 read -r confirm
483 read -r confirm
484 [ "$confirm" != "y" ] && exit 1
484 [ "$confirm" != "y" ] && exit 1
485
485
486 # Make sure all missing required packages are installed
486 # Make sure all missing required packages are installed
487 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
487 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
488 fi
488 fi
489
489
490 # Check if ./bootstrap.d directory exists
490 # Check if ./bootstrap.d directory exists
491 if [ ! -d "./bootstrap.d/" ] ; then
491 if [ ! -d "./bootstrap.d/" ] ; then
492 echo "error: './bootstrap.d' required directory not found!"
492 echo "error: './bootstrap.d' required directory not found!"
493 exit 1
493 exit 1
494 fi
494 fi
495
495
496 # Check if ./files directory exists
496 # Check if ./files directory exists
497 if [ ! -d "./files/" ] ; then
497 if [ ! -d "./files/" ] ; then
498 echo "error: './files' required directory not found!"
498 echo "error: './files' required directory not found!"
499 exit 1
499 exit 1
500 fi
500 fi
501
501
502 # Check if specified KERNELSRC_DIR directory exists
502 # Check if specified KERNELSRC_DIR directory exists
503 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
503 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
504 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
504 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
505 exit 1
505 exit 1
506 fi
506 fi
507
507
508 # Check if specified UBOOTSRC_DIR directory exists
508 # Check if specified UBOOTSRC_DIR directory exists
509 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
509 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
510 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
510 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
511 exit 1
511 exit 1
512 fi
512 fi
513
513
514 # Check if specified VIDEOCORESRC_DIR directory exists
514 # Check if specified VIDEOCORESRC_DIR directory exists
515 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
515 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
516 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
516 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
517 exit 1
517 exit 1
518 fi
518 fi
519
519
520 # Check if specified FBTURBOSRC_DIR directory exists
520 # Check if specified FBTURBOSRC_DIR directory exists
521 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
521 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
522 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
522 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
523 exit 1
523 exit 1
524 fi
524 fi
525
525
526 # Check if specified NEXMONSRC_DIR directory exists
526 # Check if specified NEXMONSRC_DIR directory exists
527 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
527 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
528 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
528 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
529 exit 1
529 exit 1
530 fi
530 fi
531
531
532 # Check if specified CHROOT_SCRIPTS directory exists
532 # Check if specified CHROOT_SCRIPTS directory exists
533 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
533 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
534 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
534 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
535 exit 1
535 exit 1
536 fi
536 fi
537
537
538 # Check if specified device mapping already exists (will be used by cryptsetup)
538 # Check if specified device mapping already exists (will be used by cryptsetup)
539 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
539 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
540 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
540 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
541 exit 1
541 exit 1
542 fi
542 fi
543
543
544 # Don't clobber an old build
544 # Don't clobber an old build
545 if [ -e "$BUILDDIR" ] ; then
545 if [ -e "$BUILDDIR" ] ; then
546 echo "error: directory ${BUILDDIR} already exists, not proceeding"
546 echo "error: directory ${BUILDDIR} already exists, not proceeding"
547 exit 1
547 exit 1
548 fi
548 fi
549
549
550 # Setup chroot directory
550 # Setup chroot directory
551 mkdir -p "${R}"
551 mkdir -p "${R}"
552
552
553 # Check if build directory has enough of free disk space >512MB
553 # Check if build directory has enough of free disk space >512MB
554 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
554 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
555 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
555 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
556 exit 1
556 exit 1
557 fi
557 fi
558
558
559 set -x
559 set -x
560
560
561 # Call "cleanup" function on various signals and errors
561 # Call "cleanup" function on various signals and errors
562 trap cleanup 0 1 2 3 6
562 trap cleanup 0 1 2 3 6
563
563
564 # Add required packages for the minbase installation
564 # Add required packages for the minbase installation
565 if [ "$ENABLE_MINBASE" = true ] ; then
565 if [ "$ENABLE_MINBASE" = true ] ; then
566 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
566 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
567 fi
567 fi
568
568
569 # Add parted package, required to get partprobe utility
569 # Add parted package, required to get partprobe utility
570 if [ "$EXPANDROOT" = true ] ; then
570 if [ "$EXPANDROOT" = true ] ; then
571 APT_INCLUDES="${APT_INCLUDES},parted"
571 APT_INCLUDES="${APT_INCLUDES},parted"
572 fi
572 fi
573
573
574 # Add dbus package, recommended if using systemd
574 # Add dbus package, recommended if using systemd
575 if [ "$ENABLE_DBUS" = true ] ; then
575 if [ "$ENABLE_DBUS" = true ] ; then
576 APT_INCLUDES="${APT_INCLUDES},dbus"
576 APT_INCLUDES="${APT_INCLUDES},dbus"
577 fi
577 fi
578
578
579 # Add iptables IPv4/IPv6 package
579 # Add iptables IPv4/IPv6 package
580 if [ "$ENABLE_IPTABLES" = true ] ; then
580 if [ "$ENABLE_IPTABLES" = true ] ; then
581 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
581 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
582 fi
582 fi
583 # Add apparmor for KERNEL_SECURITY
583 # Add apparmor for KERNEL_SECURITY
584 if [ "$KERNEL_SECURITY" = true ] ; then
584 if [ "$KERNEL_SECURITY" = true ] ; then
585 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
585 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
586 fi
586 fi
587
587
588 # Add openssh server package
588 # Add openssh server package
589 if [ "$ENABLE_SSHD" = true ] ; then
589 if [ "$ENABLE_SSHD" = true ] ; then
590 APT_INCLUDES="${APT_INCLUDES},openssh-server"
590 APT_INCLUDES="${APT_INCLUDES},openssh-server"
591 fi
591 fi
592
592
593 # Add alsa-utils package
593 # Add alsa-utils package
594 if [ "$ENABLE_SOUND" = true ] ; then
594 if [ "$ENABLE_SOUND" = true ] ; then
595 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
595 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
596 fi
596 fi
597
597
598 # Add rng-tools package
598 # Add rng-tools package
599 if [ "$ENABLE_HWRANDOM" = true ] ; then
599 if [ "$ENABLE_HWRANDOM" = true ] ; then
600 APT_INCLUDES="${APT_INCLUDES},rng-tools"
600 APT_INCLUDES="${APT_INCLUDES},rng-tools"
601 fi
601 fi
602
602
603 # Add fbturbo video driver
603 # Add fbturbo video driver
604 if [ "$ENABLE_FBTURBO" = true ] ; then
604 if [ "$ENABLE_FBTURBO" = true ] ; then
605 # Enable xorg package dependencies
605 # Enable xorg package dependencies
606 ENABLE_XORG=true
606 ENABLE_XORG=true
607 fi
607 fi
608
608
609 # Add user defined window manager package
609 # Add user defined window manager package
610 if [ -n "$ENABLE_WM" ] ; then
610 if [ -n "$ENABLE_WM" ] ; then
611 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
611 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
612
612
613 # Enable xorg package dependencies
613 # Enable xorg package dependencies
614 ENABLE_XORG=true
614 ENABLE_XORG=true
615 fi
615 fi
616
616
617 # Add xorg package
617 # Add xorg package
618 if [ "$ENABLE_XORG" = true ] ; then
618 if [ "$ENABLE_XORG" = true ] ; then
619 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
619 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
620 fi
620 fi
621
621
622 # Replace selected packages with smaller clones
622 # Replace selected packages with smaller clones
623 if [ "$ENABLE_REDUCE" = true ] ; then
623 if [ "$ENABLE_REDUCE" = true ] ; then
624 # Add levee package instead of vim-tiny
624 # Add levee package instead of vim-tiny
625 if [ "$REDUCE_VIM" = true ] ; then
625 if [ "$REDUCE_VIM" = true ] ; then
626 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
626 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
627 fi
627 fi
628
628
629 # Add dropbear package instead of openssh-server
629 # Add dropbear package instead of openssh-server
630 if [ "$REDUCE_SSHD" = true ] ; then
630 if [ "$REDUCE_SSHD" = true ] ; then
631 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
631 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
632 fi
632 fi
633 fi
633 fi
634
634
635 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
635 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
636 if [ "$ENABLE_SYSVINIT" = false ] ; then
636 if [ "$ENABLE_SYSVINIT" = false ] ; then
637 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
637 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
638 fi
638 fi
639
639
640 # Configure kernel sources if no KERNELSRC_DIR
640 # Configure kernel sources if no KERNELSRC_DIR
641 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
641 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
642 KERNELSRC_CONFIG=true
642 KERNELSRC_CONFIG=true
643 fi
643 fi
644
644
645 # Configure reduced kernel
645 # Configure reduced kernel
646 if [ "$KERNEL_REDUCE" = true ] ; then
646 if [ "$KERNEL_REDUCE" = true ] ; then
647 KERNELSRC_CONFIG=false
647 KERNELSRC_CONFIG=false
648 fi
648 fi
649
649
650 # Configure qemu compatible kernel
650 # Configure qemu compatible kernel
651 if [ "$ENABLE_QEMU" = true ] ; then
651 if [ "$ENABLE_QEMU" = true ] ; then
652 DTB_FILE=vexpress-v2p-ca15_a7.dtb
652 DTB_FILE=vexpress-v2p-ca15_a7.dtb
653 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
653 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
654 KERNEL_DEFCONFIG="vexpress_defconfig"
654 KERNEL_DEFCONFIG="vexpress_defconfig"
655 if [ "$KERNEL_MENUCONFIG" = false ] ; then
655 if [ "$KERNEL_MENUCONFIG" = false ] ; then
656 KERNEL_OLDDEFCONFIG=true
656 KERNEL_OLDDEFCONFIG=true
657 fi
657 fi
658 fi
658 fi
659
659
660 # Execute bootstrap scripts
660 # Execute bootstrap scripts
661 for SCRIPT in bootstrap.d/*.sh; do
661 for SCRIPT in bootstrap.d/*.sh; do
662 head -n 3 "$SCRIPT"
662 head -n 3 "$SCRIPT"
663 . "$SCRIPT"
663 . "$SCRIPT"
664 done
664 done
665
665
666 ## Execute custom bootstrap scripts
666 ## Execute custom bootstrap scripts
667 if [ -d "custom.d" ] ; then
667 if [ -d "custom.d" ] ; then
668 for SCRIPT in custom.d/*.sh; do
668 for SCRIPT in custom.d/*.sh; do
669 . "$SCRIPT"
669 . "$SCRIPT"
670 done
670 done
671 fi
671 fi
672
672
673 # Execute custom scripts inside the chroot
673 # Execute custom scripts inside the chroot
674 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
674 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
675 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
675 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
676 chroot_exec /bin/bash -x <<'EOF'
676 chroot_exec /bin/bash -x <<'EOF'
677 for SCRIPT in /chroot_scripts/* ; do
677 for SCRIPT in /chroot_scripts/* ; do
678 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
678 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
679 $SCRIPT
679 $SCRIPT
680 fi
680 fi
681 done
681 done
682 EOF
682 EOF
683 rm -rf "${R}/chroot_scripts"
683 rm -rf "${R}/chroot_scripts"
684 fi
684 fi
685
685
686 # Remove c/c++ build environment from the chroot
686 # Remove c/c++ build environment from the chroot
687 chroot_remove_cc
687 chroot_remove_cc
688
688
689 # Generate required machine-id
689 # Generate required machine-id
690 MACHINE_ID=$(dbus-uuidgen)
690 MACHINE_ID=$(dbus-uuidgen)
691 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
691 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
692 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
692 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
693
693
694 # APT Cleanup
694 # APT Cleanup
695 chroot_exec apt-get -y clean
695 chroot_exec apt-get -y clean
696 chroot_exec apt-get -y autoclean
696 chroot_exec apt-get -y autoclean
697 chroot_exec apt-get -y autoremove
697 chroot_exec apt-get -y autoremove
698
698
699 # Unmount mounted filesystems
699 # Unmount mounted filesystems
700 umount -l "${R}/proc"
700 umount -l "${R}/proc"
701 umount -l "${R}/sys"
701 umount -l "${R}/sys"
702
702
703 # Clean up directories
703 # Clean up directories
704 rm -rf "${R}/run/*"
704 rm -rf "${R}/run/*"
705 rm -rf "${R}/tmp/*"
705 rm -rf "${R}/tmp/*"
706
706
707 # Clean up APT proxy settings
707 # Clean up APT proxy settings
708 if [ "$KEEP_APT_PROXY" = false ] ; then
708 if [ "$KEEP_APT_PROXY" = false ] ; then
709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
710 fi
710 fi
711
711
712 # Clean up files
712 # Clean up files
713 rm -f "${ETC_DIR}/ssh/ssh_host_*"
713 rm -f "${ETC_DIR}/ssh/ssh_host_*"
714 rm -f "${ETC_DIR}/dropbear/dropbear_*"
714 rm -f "${ETC_DIR}/dropbear/dropbear_*"
715 rm -f "${ETC_DIR}/apt/sources.list.save"
715 rm -f "${ETC_DIR}/apt/sources.list.save"
716 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
716 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
717 rm -f "${ETC_DIR}/*-"
717 rm -f "${ETC_DIR}/*-"
718 rm -f "${ETC_DIR}/resolv.conf"
718 rm -f "${ETC_DIR}/resolv.conf"
719 rm -f "${R}/root/.bash_history"
719 rm -f "${R}/root/.bash_history"
720 rm -f "${R}/var/lib/urandom/random-seed"
720 rm -f "${R}/var/lib/urandom/random-seed"
721 rm -f "${R}/initrd.img"
721 rm -f "${R}/initrd.img"
722 rm -f "${R}/vmlinuz"
722 rm -f "${R}/vmlinuz"
723 rm -f "${R}${QEMU_BINARY}"
723 rm -f "${R}${QEMU_BINARY}"
724
724
725 if [ "$ENABLE_QEMU" = true ] ; then
725 if [ "$ENABLE_QEMU" = true ] ; then
726 # Setup QEMU directory
726 # Setup QEMU directory
727 mkdir "${BASEDIR}/qemu"
727 mkdir "${BASEDIR}/qemu"
728
728
729 # Copy kernel image to QEMU directory
729 # Copy kernel image to QEMU directory
730 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
730 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
731
731
732 # Copy kernel config to QEMU directory
732 # Copy kernel config to QEMU directory
733 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
733 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
734
734
735 # Copy kernel dtbs to QEMU directory
735 # Copy kernel dtbs to QEMU directory
736 for dtb in "${BOOT_DIR}/"*.dtb ; do
736 for dtb in "${BOOT_DIR}/"*.dtb ; do
737 if [ -f "${dtb}" ] ; then
737 if [ -f "${dtb}" ] ; then
738 install_readonly "${dtb}" "${BASEDIR}/qemu/"
738 install_readonly "${dtb}" "${BASEDIR}/qemu/"
739 fi
739 fi
740 done
740 done
741
741
742 # Copy kernel overlays to QEMU directory
742 # Copy kernel overlays to QEMU directory
743 if [ -d "${BOOT_DIR}/overlays" ] ; then
743 if [ -d "${BOOT_DIR}/overlays" ] ; then
744 # Setup overlays dtbs directory
744 # Setup overlays dtbs directory
745 mkdir "${BASEDIR}/qemu/overlays"
745 mkdir "${BASEDIR}/qemu/overlays"
746
746
747 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
747 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
748 if [ -f "${dtb}" ] ; then
748 if [ -f "${dtb}" ] ; then
749 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
749 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
750 fi
750 fi
751 done
751 done
752 fi
752 fi
753
753
754 # Copy u-boot files to QEMU directory
754 # Copy u-boot files to QEMU directory
755 if [ "$ENABLE_UBOOT" = true ] ; then
755 if [ "$ENABLE_UBOOT" = true ] ; then
756 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
756 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
757 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
757 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
758 fi
758 fi
759 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
759 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
760 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
760 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
761 fi
761 fi
762 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
762 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
763 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
763 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
764 fi
764 fi
765 fi
765 fi
766
766
767 # Copy initramfs to QEMU directory
767 # Copy initramfs to QEMU directory
768 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
768 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
769 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
769 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
770 fi
770 fi
771 fi
771 fi
772
772
773 # Calculate size of the chroot directory in KB
773 # Calculate size of the chroot directory in KB
774 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
774 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
775
775
776 # Calculate the amount of needed 512 Byte sectors
776 # Calculate the amount of needed 512 Byte sectors
777 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
777 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
778 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
778 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
779 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
779 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
780
780
781 # The root partition is EXT4
781 # The root partition is EXT4
782 # This means more space than the actual used space of the chroot is used.
782 # This means more space than the actual used space of the chroot is used.
783 # As overhead for journaling and reserved blocks 35% are added.
783 # As overhead for journaling and reserved blocks 35% are added.
784 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
784 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
785
785
786 # Calculate required image size in 512 Byte sectors
786 # Calculate required image size in 512 Byte sectors
787 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
787 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
788
788
789 # Prepare image file
789 # Prepare image file
790 if [ "$ENABLE_SPLITFS" = true ] ; then
790 if [ "$ENABLE_SPLITFS" = true ] ; then
791 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
791 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
792 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
792 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
793 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
793 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
794 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
794 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
795
795
796 # Write firmware/boot partition tables
796 # Write firmware/boot partition tables
797 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
797 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
798 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
798 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
799 EOM
799 EOM
800
800
801 # Write root partition table
801 # Write root partition table
802 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
802 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
803 ${TABLE_SECTORS},${ROOT_SECTORS},83
803 ${TABLE_SECTORS},${ROOT_SECTORS},83
804 EOM
804 EOM
805
805
806 # Setup temporary loop devices
806 # Setup temporary loop devices
807 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
807 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
808 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
808 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
809 else # ENABLE_SPLITFS=false
809 else # ENABLE_SPLITFS=false
810 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
810 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
811 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
811 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
812
812
813 # Write partition table
813 # Write partition table
814 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
814 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
815 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
815 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
816 ${ROOT_OFFSET},${ROOT_SECTORS},83
816 ${ROOT_OFFSET},${ROOT_SECTORS},83
817 EOM
817 EOM
818
818
819 # Setup temporary loop devices
819 # Setup temporary loop devices
820 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
820 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
821 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
821 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
822 fi
822 fi
823
823
824 if [ "$ENABLE_CRYPTFS" = true ] ; then
824 if [ "$ENABLE_CRYPTFS" = true ] ; then
825 # Create dummy ext4 fs
825 # Create dummy ext4 fs
826 mkfs.ext4 "$ROOT_LOOP"
826 mkfs.ext4 "$ROOT_LOOP"
827
827
828 # Setup password keyfile
828 # Setup password keyfile
829 touch .password
829 touch .password
830 chmod 600 .password
830 chmod 600 .password
831 echo -n ${CRYPTFS_PASSWORD} > .password
831 echo -n ${CRYPTFS_PASSWORD} > .password
832
832
833 # Initialize encrypted partition
833 # Initialize encrypted partition
834 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
834 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
835
835
836 # Open encrypted partition and setup mapping
836 # Open encrypted partition and setup mapping
837 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
837 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
838
838
839 # Secure delete password keyfile
839 # Secure delete password keyfile
840 shred -zu .password
840 shred -zu .password
841
841
842 # Update temporary loop device
842 # Update temporary loop device
843 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
843 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
844
844
845 # Wipe encrypted partition (encryption cipher is used for randomness)
845 # Wipe encrypted partition (encryption cipher is used for randomness)
846 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
846 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
847 fi
847 fi
848
848
849 # Build filesystems
849 # Build filesystems
850 mkfs.vfat "$FRMW_LOOP"
850 mkfs.vfat "$FRMW_LOOP"
851 mkfs.ext4 "$ROOT_LOOP"
851 mkfs.ext4 "$ROOT_LOOP"
852
852
853 # Mount the temporary loop devices
853 # Mount the temporary loop devices
854 mkdir -p "$BUILDDIR/mount"
854 mkdir -p "$BUILDDIR/mount"
855 mount "$ROOT_LOOP" "$BUILDDIR/mount"
855 mount "$ROOT_LOOP" "$BUILDDIR/mount"
856
856
857 mkdir -p "$BUILDDIR/mount/boot/firmware"
857 mkdir -p "$BUILDDIR/mount/boot/firmware"
858 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
858 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
859
859
860 # Copy all files from the chroot to the loop device mount point directory
860 # Copy all files from the chroot to the loop device mount point directory
861 rsync -a "${R}/" "$BUILDDIR/mount/"
861 rsync -a "${R}/" "$BUILDDIR/mount/"
862
862
863 # Unmount all temporary loop devices and mount points
863 # Unmount all temporary loop devices and mount points
864 cleanup
864 cleanup
865
865
866 # Create block map file(s) of image(s)
866 # Create block map file(s) of image(s)
867 if [ "$ENABLE_SPLITFS" = true ] ; then
867 if [ "$ENABLE_SPLITFS" = true ] ; then
868 # Create block map files for "bmaptool"
868 # Create block map files for "bmaptool"
869 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
869 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
870 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
870 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
871
871
872 # Image was successfully created
872 # Image was successfully created
873 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
873 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
874 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
874 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
875 else
875 else
876 # Create block map file for "bmaptool"
876 # Create block map file for "bmaptool"
877 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
877 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
878
878
879 # Image was successfully created
879 # Image was successfully created
880 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
880 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
881
881
882 # Create qemu qcow2 image
882 # Create qemu qcow2 image
883 if [ "$ENABLE_QEMU" = true ] ; then
883 if [ "$ENABLE_QEMU" = true ] ; then
884 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
884 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
885 QEMU_SIZE=16G
885 QEMU_SIZE=16G
886
886
887 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
887 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
888 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
888 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
889
889
890 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
890 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
891 fi
891 fi
892 fi
892 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant